/* 
        Cell.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarinwin maslβŸ򸵤Yamahata
	ޤ
	MITSHM extentionʬĹ(nagano@i.kyushu-u.ac.jp )
	xmasl򻲹ͤˤƤޤ

*/
#include <stdlib.h>
//#include <cstdlib>

#include "Cell.h"

int Cell::depth=8;
unsigned long Cell::basePixel;
GDC2PLANEMASK Cell::planeMask;
unsigned char Cell::palette2Pixel[NUMBER_OF_COLORS];

Cell::Cell (MaslInputStream& maslIs,const unsigned char ak5ID):
  cellData (NULL),
  address (0),offset (0),gdcLoop (PLANE_LENGTH)
{
  gdc.b=gdc.r=gdc.g=gdc.e=0;

  //header.parentFileName=NULL;
  header.ak5id=ak5ID;
  if ((header.ak5id==AK5ID_DIFF)||(header.ak5id==AK5ID_DIFF_FAST))
    {//ʬdataǤä
      maslIs.read (header.parentFileName,16);//ʬfile nameɤߤ
      header.parentFileName[16]='\0';
/*
#ifdef DEBUG
      cerr << "parent=" << header.parentFileName << endl;
#endif      
*/
    }
  
  maslIs.read (header.fileName,16);//file nameɤߤ
  header.fileName[16]='\0';
/*
#ifdef DEBUG
  cerr << header.fileName << endl;
#endif
*/  
  header.left=maslIs.get16 ();
  header.left*=8;//XbyteʤΤdotľƤ롣
  header.top=maslIs.get16 ();

  header.right=maslIs.get16 ();
  ++header.right*=8;
  header.bottom=maslIs.get16 ();
  header.bottom++;
/*
#ifdef DEBUG
  cerr << "header.left=" << header.left << endl;
  cerr << "header.top=" << header.top << endl;
  cerr << "header.right=" << header.right << endl;
  cerr << "header.bottom=" << header.bottom << endl;
#endif  
*/
  //file sizeɤ߹
  header.dataSize=maslIs.get16 ();
/*
#ifdef DEBUG
  cout << "header.dataSize=" << header.dataSize << "byte" << endl;
#endif  
*/
  cellData= new unsigned char[header.dataSize];
  maslIs.read (cellData,header.dataSize);
}

Cell::Cell ():
  cellData (NULL),
  address (0),offset (0),gdcLoop (PLANE_LENGTH)
{
  //do nothing
}

Cell::~Cell ()
{
  delete[] cellData;
}


void Cell::putImage (Display* const display,Visual* const visual,
		     const Drawable drawable,const GC gc,
		     const int left,const int top)
{
  //XImageѴ
  //8bit˷ᤦƤ롣
  unsigned char* const imageData=new unsigned char[PLANE_LENGTH*8];
  memset (imageData,basePixel,PLANE_LENGTH*8);//memory 
  XImage* ximage=XCreateImage (display,visual,(unsigned int) 8,ZPixmap,0,
		      (char*) imageData,SIZE_X,SIZE_Y,8,0);
  ximage->byte_order=MSBFirst;
  ximage->bitmap_bit_order=MSBFirst;


  if (!(extractCell2XImage (cellData,imageData)))
    {
      exit (-1);//error٤
    }

/*
#ifdef DEBUG
  cout << "header.left=" << header.left << endl;
  cout << "header.top=" << header.top << endl;
  cout << "header.right=" << header.right << endl;
  cout << "header.bottom=" << header.bottom << endl;
#endif
*/
#ifdef MITSHM
  XShmPutImage (display,drawable,gc,ximage,
		0,0,left,top,SIZE_X,SIZE_Y,False);
#else
  XPutImage (display,drawable,gc,ximage,0,0,left,top,
    	     SIZE_X,SIZE_Y);
#endif//MITSHM
  
  delete[] imageData;
  ximage->data=NULL;
  XDestroyImage (ximage);
}


void Cell::putImage (Display* const display,const Drawable drawable,
		     const GC gc,XImage* const ximage,
		     const int left=0,const int top=0)
{


  if (!(extractCell2XImage (cellData,(unsigned char*) ximage->data)))
    {
      exit (-1);//error٤
    }

#ifdef MITSHM
  XShmPutImage (display,drawable,gc,ximage,
		0,0,left,top,SIZE_X,SIZE_Y,False);
#else
  XPutImage (display,drawable,gc,ximage,0,0,left,top,
    	     SIZE_X,SIZE_Y);
#endif//MITSHM
}

void Cell::prepareCell (const int maslDepth,
			unsigned long planes[DEPTHOFAK5],
			const unsigned long basePxl)
{
  depth=maslDepth;
  basePixel=basePxl;

  planeMask.b=planes[0];
  planeMask.r=planes[1];
  planeMask.g=planes[2];
  planeMask.e=planes[3];

  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {
      palette2Pixel[i]=
        basePixel|
        ((i&1)?planes[0]:0)|
        ((i&2)?planes[1]:0)|
        ((i&4)?planes[2]:0)|
        ((i&8)?planes[3]:0);
    }
}

/////////////////////////////////////////////////XImage->dataؿ


void Cell::copyImage (const unsigned char* const src,
		      unsigned char* const dest)
{
  //memcpy (imageData[dest],imageData[src],PLANE_LENGTH*8);
  memcpy (dest,src,VRAM_LENGTH*8);
}

void Cell::moveRect (unsigned char* const imageData,
		     const RECT src,const int destLeft,const int destTop)
{
  const int width=src.right-src.left+1;
  const int height=src.bottom-src.top+1;
  //8bit˷ᤦ
  unsigned char* tmp=new unsigned char[(width*8)*height];
  {//moveζФƤ
    for (int j=0;j<=height;j++)
      memcpy (tmp+j*width*8,
	      imageData+src.left*8+(src.top+j)*SIZE_X,
	      width*8);
  }
  {//ĥդ褹
    for (int j=0;j<=height;j++)
      memcpy (imageData+destLeft*8+(destTop+j)*SIZE_X,
	      tmp+j*width*8,
	      width*8);
  }
  delete[] tmp;
}

void Cell::GDCRollImageData (unsigned char* const imageData,
			     const int GDCRoll,const unsigned short gdcLoop)
{//vramɽ֤GDCRollbyteʬ餹
  //gdcLoop byteloop
  unsigned char* tmp=new unsigned char[abs (GDCRoll*2*8)];
  if (GDCRoll>0)
    {
      memcpy (tmp,imageData,GDCRoll*2*8);
      memmove (imageData,imageData+GDCRoll*2*8,(gdcLoop-GDCRoll*2)*8);
      memcpy (imageData+(gdcLoop-GDCRoll*2)*8,tmp,GDCRoll*2*8);
    }
  else if (GDCRoll<0)
    {
      memcpy (tmp,imageData+(gdcLoop+GDCRoll*2)*8,-GDCRoll*2*8);
      memmove (imageData-GDCRoll*2*8,imageData,(gdcLoop+GDCRoll*2)*8);
      memcpy (imageData,tmp,-GDCRoll*2*8);
    }
  delete[] tmp;
}


void Cell::drawBox (unsigned char* const imageData,
		    const int x1,const int y1,const int x2,const int y2,
		    const int b,const int r,const int g,const int e)
{//x1,y1,x2,y2ñ̤dot
  //i.e.0<=x1,x2<SIZE_X 0<=y1,y2<SIZE_YǤ롣
  assert (x1<=x2 && y1<=y2);

  for (int y=y1;y<=y2;y++)
    {
      for (int x=x1;x<=x2;x++)
	{
	  const int tmpOffset=((x+y*SIZE_X)/8)%VRAM_LENGTH;
	  //const int tmpOffset=((x+y*SIZE_X)/8)&(VRAM_LENGTH-1);
	  for (int i=0;i<8;i++)
	    {
	      //b=plane 0,r=plane 1,g=plane 2,e=plane 3Ǥա
	      *(imageData+tmpOffset*8+i)=palette2Pixel
		[(((b << i)&0x80) >> 7)|(((r << i)&0x80) >> 6)|
		(((g << i)&0x80) >> 5)|(((e << i)&0x80) >> 4)];

	      /*
	       *(imageData+tmpOffset*8+i)=
	       basePixel|
	       (((b << i)&0x80)?planeMask.b:0)|
	       (((r << i)&0x80)?planeMask.r:0)|
	       (((g << i)&0x80)?planeMask.g:0)|
	       (((e << i)&0x80)?planeMask.e:0);
	       */
	    }
	}
    }
}


void Cell::clearImage (unsigned char* const imageData)
{
  memset (imageData, basePixel,VRAM_LENGTH*8);
}
