/* 
        Cell.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
	codeshimarinwin maslβŸ򸵤Yamahata
	ޤ
	MITSHM extentionʬĹ(nagano@i.kyushu-u.ac.jp )
	xmasl򻲹ͻƤޤ

*/

//C++
#include <iostream.h>

//C
#include <assert.h>
//#include <cassert>
#include <stdio.h>
//#include <cstdio>
#include <string.h>
//#include <cstring>

//X
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#ifdef MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

#include "MaslConst.h"
#include "MaslInputStream.h"

#ifndef cell_h
#define cell_h

#define GDC_B_MASK (0x01)
#define GDC_R_MASK (0x01<<1)
#define GDC_G_MASK (0x01<<2)
#define GDC_E_MASK (0x01<<3)

struct GDC
{
  unsigned char b;//plane 0
  unsigned char r;//plane 1
  unsigned char g;//plane 2
  unsigned char e;//plane 3
};

struct GDC2PLANEMASK
{
  unsigned long b;//plane 0
  unsigned long r;//plane 1
  unsigned long g;//plane 2
  unsigned long e;//plane 3
};

struct cellheader
{
  unsigned char ak5id;//1byte:ak5ΤɤηfileAK5_{NORM,DIFF}[_FAST]
  //char parentFileName[17]=NULL;//16byte:ʬfile name
  char parentFileName[17];//16byte:ʬfile name
  char fileName[17];//16byte:file name
  int left,top,right,bottom;//2bytex4:save area
  unsigned short dataSize;//data礭θsize byteCell dataͭ롣

};



class Cell
{
  //variables  
#ifdef TEST_AK5
public:
#else
protected:
#endif
  cellheader header;
  unsigned char *cellData;//dataƬؤpointer
  //constructϲdataΤؤ(header)Ѳʤ

  static int depth;//=8;//depth of color ̤οο
  static unsigned long basePixel;//base pixel

  //Ÿ˻Ȥ
  int address;//98 VRAM address - 0xa800
  int offset;//offsetĤޤºݤˤaddress+offsetΰ֤褵롣
  //ȤäƤΤGRCG2XImageΤ
  int gdcLoop;//address<0λˤaddress+gdcLoopΰ֤褹
  //GDC scrollλɬס
  //ȤäƤΤGRCG2XImageΤ
  GDC gdc;//
  static GDC2PLANEMASK planeMask;//plane mask
  static unsigned char palette2Pixel[NUMBER_OF_COLORS];

  //methods
protected:
  virtual void GRCG2XImage (const int address,unsigned char* const imagePointer);
  inline void drawN (const int n,const unsigned char GRCG,
		     unsigned char*& cellPointer,
		     unsigned char* const imagePointer,
		     const Bool isSkip2Line);
  
  inline void nextLine (const Bool isSkip2Line);//extractCell2Imageɬ

public:
  Cell (MaslInputStream& maslIs,const unsigned char ak5ID);
  Cell ();//CellAheadä˲⤷ʤ
  friend class CellAhead;
  virtual ~Cell ();
  static void prepareCell (const int maslDepth,
			   unsigned long planes[DEPTHOFAK5],
			   const unsigned long basePxl);
protected:
  virtual Bool extractCell2XImage (unsigned char* const cellData,
				   unsigned char* const imageData,
				   const int maslOffset=0,
				   const int maslGdcLoop=PLANE_LENGTH);
public:
  virtual Bool extractCell2XImage (unsigned char* const imageData,
				   const int maslOffset=0,
				   const int maslGdcLoop=PLANE_LENGTH);
  virtual Bool extractCell2XImage (XImage* const ximage,
				   const int maslOffset=0,
				   const int maslGdcLoop=PLANE_LENGTH);
  
  void putImage (Display* const display,Visual* const visual,
		 const Drawable drawable,const GC gc,
		 const int left,const int top);
  void putImage (Display* const display,const Drawable drawable,
		 const GC gc,XImage* const ximage,
		 const int left,const int top);

//////////////////////////////////////////////XImage->dataؿ
public:
  static void copyImage (const unsigned char* const src,
			 unsigned char* const dest);
  //image datasrcdestcopy롣
  static void moveRect (unsigned char* const imageData,
			const RECT src,const int destLeft,const int destTop);
  //'move x1,y1,x2,y2,x3,y3'(1.1)
  //x1,x2ñ̤byte(i.e. 0<=x1,x2<=SIZE_X/8)
  //y1,y2ñ̤dot(i.e 0<=y1,y2<=SIZE_Y)

  static void GDCRollImageData (unsigned char* const imageData,
				const int GDCRoll,const unsigned short gdcLoop);
  //'rollP1[,P2]'
  //GDCRollŪˤɤ餹(P1ǤϤʤơꤷͤȤκ)
  //gdcLoopP2ˤäƷޤꡢbyteloop뤫Ϳ롣

  static void drawBox (unsigned char* const imageData,
		       const int x1,const int y1,const int x2,const int y2,
		       const int b,const int r,const int g,const int e);
  //'box x1,y1,x2,y2,b,r,g,e'
  //x1,x2ñ̤dot(i.e. 0<=x1,x2<=SIZE_X)moveRectȰ㤦Τ
  //y1,y2ñ̤dot(i.e 0<=y1,y2<=SIZE_Y)
  
  static void clearImage (unsigned char* const imageData);

};
#endif//cell_h
