/* 
        Masl.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        codeshimarincode򸵤YamahataľʪǤ
	ޤcommentˤKunimaslֺ(maslt120.lzh)ѤƤ
	ʬͭޤ
	MITSHM extentionʬĹ(nagano@i.kyushu-u.ac.jp )
	xmasl򻲹ͤˤƤޤ
	sjis->eucѴʬ δ(shirai@nintendo.co.jp)FD-clone
        codeȤ碌ĺޤ
        >FDclone ϡ[  δ <shirai@red.nintendo.co.jp> ]
        >ݻޤâƤΥۡѡѡ2 
        >ˤĤƤϡ«뤳Ȥʤͳ˹Ԥʤäĺƹ
        >
*/

#include "Masl.h"
#include "Cell.h"
#include "CellStatic.h"
#include "SvgaPalette.h"
#include "Pcm.h"
#include "audio.h"
#include "MaslAudio.h"

/*
*constructor for Masl
*/
Masl::Masl (const int __argc,char** const __argv,
	    const char* const filename,
	    XMASL_OPTION maslXmaslOption):
  argc (__argc),argv (__argv),
  scenario (NULL),
  numberOfCell (0),numberOfPalette (0),numberOfPcm (0),
  imageDataOf200Line (NULL),
  numberOfCall (0),numberOfLoop (0),
  is200LineMode (False),isGraphicOn (True),
  viewPort (0,0,SIZE_X,SIZE_Y),
  nVramOrg (0),gdcLoop (PLANE_LENGTH),
  timer (60*100),timeCntForWait (0), isWaiting (False),
  aheadlyExtractedCellNumber (-1),cellAhead (NULL),
  isAudioWriting (False),isAudioWaiting (False),
  errorLevel (NULL),
  normalExit (0),escapeExit (-1),//ΣĤνͤˤϰ̣ͭޤ
  xmaslOption (maslXmaslOption)
{
  ////////////////////////////////////////ѿ
  setXmaslOption (xmaslOption);
  imageData[0]=new unsigned char[VRAM_LENGTH*8];
  imageData[1]=new unsigned char[VRAM_LENGTH*8];
  
  
  ////////////////////////////////////////////////setup svgalib & svgagl
  vga_init ();
  setSvgaMode (TEXT);
  physicalScreen=gl_allocatecontext ();
  gl_getcontext (physicalScreen);
  //////////////¾
  unsigned long planes[DEPTHOFAK5];
  for (int i=0;i<DEPTHOFAK5;i++)
    planes[i]=(1UL << i);
  Cell::prepareCell (DEPTHOFAK5,planes,0L);


  //fileload
  if (!loadAll (filename))
    {//fileloadʤä
      cerr << "Can not load masl file." << endl;
      exit (-1);//λ
    }
  setSvgaMode (G640x480x256);
  gl_enableclipping ();
  gl_setclippingwindow (0,VERTICAL_OFFSET,SIZE_X,SIZE_Y);
}


Masl::~Masl ()
{
  vga_setmode (TEXT);
  gl_freecontext (physicalScreen);
  
  delete[] imageData[1];
  delete[] imageData[2];
  delete[] imageDataOf200Line;

  delete scenario;
  {for (int i=0;i<numberOfPalette;i++) delete pPalette[i];}
  {for (int i=0;i<numberOfCell;i++) delete pCell[i];}
  {for (int i=0;i<numberOfPcm;i++) delete pPcm[i];}
  delete cellAhead;
}

////////////////////////////////////////////////xmaslФoptionν
void Masl::setXmaslOption (XMASL_OPTION xmaslOption)
{
  if (xmaslOption.isNoSound)
    MaslAudio::disableAudio ();

#ifdef RENICE
  if (xmaslOption.isRenice)
    {
      if (setpriority (PRIO_PROCESS,0,RENICE_LEVEL)==-1)
	perror ("can not set priority");
    }
  uid_t userId=getuid ();
  setuid (userId);
  //setreuid (userId,userId);
#endif//RENICE
}

/*
*ak5 dataɤ߹
*/
Bool Masl::ak5Load (MaslInputStream& maslIs)
{
  unsigned int length;
  /////////////////////////////////////////////////data lenghtɤ߹
  length=maslIs.get32 ();
  
  if (length==0)
    length-=1;
  
  long endptr=maslIs.tellg ()+length;//ak5 dataνü


  ///////////////////////////////////////////////////AK5* ɤ߹
  char ak5[9];
  maslIs.read (ak5,8);
  ak5[8]='\0';
  if (strncmp (ak5,"AK5",3)!=0)
    {
      cerr << "Incorrect data format detected." << endl;
      return False;
    }
  
  //ΰϲ򤷤Ƥ뤫
  char fix1[32];
  maslIs.read (fix1,32);

  ///////////////////////////////////////////////////////dataɤ߹
  while (maslIs.tellg ()<endptr)
    {
      unsigned char ak5Id;
      ak5Id=maslIs.get ();
      
      switch (ak5Id)
	{
	case AK5ID_PAL://palette dataɤ߹
	  pPalette[numberOfPalette++]=new SvgaPalette(maslIs);
	  break;
	  
	case AK5ID_NORM://ľ
	case AK5ID_DIFF://ľ
	case AK5ID_NORM_FAST://ľ
	case AK5ID_DIFF_FAST://dataɤ߹
	  if (xmaslOption.isStaticLowMemory)
	    {
	      pCell[numberOfCell++]=new CellStaticLowMemory (maslIs,ak5Id);
	    }
	  else if (xmaslOption.isStatic)
	    {//dataŪŸ롣
	      pCell[numberOfCell++]=new CellStatic (maslIs,ak5Id);
	    }
	  else
	    {//dataưŪŸ롣default
	      pCell[numberOfCell++]=new Cell (maslIs,ak5Id);
	    }
	  break;
	  
	default://̾Ϥؤʤ
	  cerr << "Incorrect Ak5 ID detected" << endl;
	  return False;
	}
    }
  return True;
}


/*
*pkn dataɤ߹
*/
Bool Masl::pknLoad (MaslInputStream& maslIs)
{
  ///////////////////////////data size
  unsigned int size;

  //data sizeɤ߹
  size=maslIs.get32 ();
  if (size==0)size-=1;
  
  long endptr=maslIs.tellg ()+size;//pkn dataνü

  ///////////////PKN* ɤ߹
  char PKN[8];
  maslIs.read (PKN,8);
  PKN[3]='\0';
  if (strncmp (PKN,"PKN",3)!=0)
    {
      cerr << "Incorrect data format detected" << endl;
      return False;
    }
  

  //ΰϲ򤷤Ƥ뤫
  char fix[32];
  maslIs.read (fix,32);//ϲ⤷ʤ

  ///////////////////////////////////////////////////////dataɤ߹
  while (maslIs.tellg ()<endptr)
    {
      unsigned char type;
      type=maslIs.get ();

      pPcm[numberOfPcm++]=new Pcm (type,maslIs);//pcm dataɤ߹
    }
  return True;
}

Bool Masl::loadAll (const char* const filename)
{

  //////////////////////////////////////////////ѿ
  numberOfCell=0;
  numberOfPalette=0;
  numberOfPcm=0;

  ///////////////////////////////////////////////fileopen
  MaslInputStream maslIs (filename,ios::in|ios::nocreate);
  
  if (!maslIs)
    {
      cerr << filename << ":File couldn't open.(file does not exst?)" << endl;
      return False;
    }
  
  ////////////////////////////////////////////////MSLɤ߹
  char MSL[9];
  maslIs.read (MSL,8);
  MSL[8]='\0';
  if (strncmp (MSL,"MSL",3)!=0)
    {
      cerr<< "This is not MSL file" << endl;
      maslIs.close ();
      return False;
    }
  
  /////////////////////////////////////////scenarioSizeɤ߹
  const int scenarioSize=maslIs.get16 ();

  ///////////////////////////////////////////scinarioɤ߹
  scenario=new MaslScenario (maslIs,scenarioSize);

  /////////////////////////////////////////////MASLcheck
  scenario->checkMagic ();
  
  ////////////////////////////////////Version Check ****.****  ver1.ver2
  //const int version=scenario->getVersion ();
  //version check˻ȤΤ
  

  /////////////////////////////////////ޥȤμ ȿ *.*Hz
  int hz=scenario->getTimerCounter ();

  if (hz<0)hz=6000;
  //ʤˤ600.00HzȤȤǤʤͤ񤤤Ƥ礬ͭΤǤк
  //ͽˤɬ񤫤ʤȤʤΤ
  timer.setCount (hz);
  
  if (!xmaslOption.isNoPrintComment)
    scenario->printComment (xmaslOption.isSjis);

  /////////////////////////////////////////////////////ak5,pkn dataɤ߹
  cout << "\nnow loading ak5 and pkn..." << flush;
  for (const char* filename=scenario->getDataFilename ();
       filename!=NULL;
       filename=scenario->getDataFilename ())
    {
      while (*filename!='.')filename++;//8+3:file̾γĥҤޤФ

      if ((filename[1]=='a' && filename[2]=='k' && filename[3]=='5') ||
	  (filename[1]=='A' && filename[2]=='K' && filename[3]=='5'))
	{//ĥҤak5ޤAK5ä
	  if (!ak5Load (maslIs))//ak5 dataɤ߹
	    {//error
	      cerr << "AK5 load Failuer." << endl;
	      maslIs.close ();
	      return False;
	    }
	}
      else if ((filename[1]=='p' && filename[2]=='k' && filename[3]=='n') ||
	       (filename[1]=='P' && filename[2]=='K' && filename[3]=='N'))
	{//ĥҤpknޤPKNä
	  if (!pknLoad (maslIs))//pkn dataɤ߹
	    {//error
	      cerr << "PKN Load failure." << endl;
	      maslIs.close ();
	      return False;
	    }
	}
      cout << "." << flush;
    }
  maslIs.close ();//ɤ߹߽λ
  cout << 
"\rLoading done.                                                              "
       << endl;

  /////////keyԤ
  //cerr << "docwait=" << docwait << endl;
  if (xmaslOption.isWaitBeforePlaying)
    waitBeforePlaying (scenario->getDocWaitValue ());
  
  //
  return True;
}


//////////////////////////////////////////////scenarioβϤΤmethod

int Masl::searchnum ()
{
  int ch;//dataɤ߹
  int fg=1;//
  int i=0;//ͤ

  pt=strpbrk (pt,"-0123456789");
  
  if (*pt=='-')
    {
      fg=-1;
      pt++;
    }
  
  while (isdigit (ch=(int (*pt))))
    {
      if (isdigit (ch))
	{
	  i*=10;
	  i+=ch-'0';
	}
      pt++;
    }
  return fg*i;
}



int Masl::searchnum (const char* pt)
{
  //  return atoi (pt);

  int ch;//dataɤ߹
  int fg=1;//
  int i=0;//ͤ
  
  pt=strpbrk (pt,"-0123456789");
  
  if (*pt=='-')
    {//ɤ߹
      fg=-1;
      pt++;
    }

  while (isdigit (ch= (int) (*pt)))
    {
      if (isdigit (ch))
	{
	  i*=10;//巫夲ơ
	  i+=ch-'0';//̤˿ɤ߹
	}
      pt++;
    }
  return fg*i;
}


Bool Masl::searchNextCommand ()
{//ͭtokenͭޤǡptʤ롣
  while ((*pt==' '||*pt=='\t'||*pt=='\r'||*pt=='\n'||*pt==';')
	 && scenario->isNotEnd (pt))
    {//򡢲ԤȤФ;ϥ
      if (*pt==';')
	{//ȤʤΤǲԤޤǤȤФ
	  pt++;
	  while (*(pt-2)!='\r'||*(pt-1)!='\n')
	    {
	      pt++;
	    }
	}
      else
	{
	  pt++;
	}
    }

  if (scenario->isEnd (pt))
    return False;
  else
    return True;
}

int Masl::getValue ()
{
  pt=strpbrk (pt,"-0123456789r@kotp");
  for (int i=0;i<NUMBER_VALUE;i++)
    {
      if (*pt==valueTable[i].value)
	return valueTable[i].getValue (*this);
    }

  //̾ϤˤʤȦ
  return 0;//defaultͭäɤΤʤ
}

Bool Masl::joukenHantei ()
{
  switch (*pt)
    {
    case '=':
      {
	pt++;
	int n=getValue ();
	pt++;//commaɤФ
	return (n==getValue ())?True:False;
      }
    break;
    
    case '!':
      {
      pt++;
      int n=getValue ();
      pt++;//commaɤФ
      return (n!=getValue ())?True:False;
      }
    break;

    case '<':
      pt++;
      if (*pt=='=')
	{//⤷
	  pt++;
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n<=getValue ())?True:False;
	}
      else
	{
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n<getValue ())?True:False;
	}
      break;

    case '>':
      pt++;
      if (*pt=='=')
	{//⤷
	  pt++;
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n>=getValue ())?True:False;
	}
      else
	{
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n>getValue ())?True:False;      
	}
      break;

    default:
      return True;	
      break;
    }
}

int Masl::isKeyPressed (const KeySym keysym,const char keyVector[32])
{
  return 0;
#if 0
  KeyCode keycode=XKeysymToKeycode (display,keysym);
  if (keycode==NoSymbol)return (0);//̵̣key codeä

  return (1&(keyVector[(keycode/8)]>> (keycode&7)));
#endif
}


Bool Masl::isOptionSpecified (char c)
{
  for (int i=1;i<argc;i++)
    {
      const char* p=argv[i];
      if (*p!='/' && *p!='-')
	continue;
      p++;
      if (tolower (*p)==tolower (c))
	return True;
    }
  return False;
}

Bool Masl::isOptionSpecified2 (const char*& opts)
{
  for (int i=1;i<argc;i++)
    {
      const char* p=argv[i];
      if (*p!='/' && *p!='-')
	  continue;
      p++;
      if (tolower (*p)==tolower (*opts) &&
	  tolower (*(p+1))==tolower (*(opts+1)))
	{
	  opts+=2;
	  return True;
	}
    }
  opts+=2;
  return False;
}

int Masl::getOptionValue (char c)
{
  for (int i=1;i<argc;i++)
    {
      const char* p=argv[i];
      if (*p!='/' && *p!='-')
	continue;
      p++;
      if (tolower (*p)==tolower (c))
	return searchnum ((char*) p+1);//+1option'/'or'-'Ф
    }
  return 0;
}

void Masl::updateWindow ()
{
  if (isGraphicOn)
    {
      if (xmaslOption.isTraceMode)
	{//////trace modeäΤǤν
	}
      putImage ();//ɽ
    }
}

void Masl::putImage ()
{
  vga_lockvc ();
  if (!vga_oktowrite ())
    {
      vga_unlockvc ();
      return;
    }
  
  //vga_waitretrace ();
  if (!is200LineMode)
    {//400 line modeä
#if 0
      gl_putbox (viewPort.left,viewPort.top+VERTICAL_OFFSET,
		 viewPort.right-viewPort.left+1,viewPort.bottom-viewPort.top+1,
		 (unsigned char*) imageData[nShowPage]);
#endif
      gl_putboxpart (viewPort.left,viewPort.top+VERTICAL_OFFSET,
		     viewPort.right-viewPort.left+1,viewPort.bottom-viewPort.top+1,
		     SIZE_X,SIZE_Y,
		     (unsigned char*) imageData[nShowPage],
		     viewPort.left,viewPort.top);
    }
  else
    {//200 line modeä
      if (imageDataOf200Line==NULL)
	{//ƸƤФ줿Τǽ
	  imageDataOf200Line=new unsigned char[VRAM_LENGTH*8];
	}

      for (int i=0;i<SIZE_Y/2;i++)
	{//200line modeʤΤǾ200line400line˳礹
	  memcpy (imageDataOf200Line+i*2*SIZE_X,
		  imageData[nShowPage]+i*SIZE_X,SIZE_X);
	  memcpy (imageDataOf200Line+(i*2+1)*SIZE_X,
		  imageData[nShowPage]+i*SIZE_X,SIZE_X);
	}
#if 0
      gl_putbox (viewPort.left,viewPort.top+VERTICAL_OFFSET,
		 viewPort.right-viewPort.left+1,viewPort.bottom-viewPort.top+1,
		 imageDataOf200Line[nShowPage]);
#endif
      gl_putboxpart (viewPort.left,viewPort.top+VERTICAL_OFFSET,
		     viewPort.right-viewPort.left+1,viewPort.bottom-viewPort.top+1,
		     SIZE_X,SIZE_Y,
		     imageDataOf200Line,
		     viewPort.left,viewPort.top);
    }
  vga_unlockvc ();
}



void Masl::clearWindow ()
{
  //pagevram(98vramǤ)0clear롣
  //Ʊ˲̤clear롣
  //XClearWindow (display,window);//isGraphicOn==Falseξɬס
  vga_lockvc ();
  if (vga_oktowrite ())
    gl_clearscreen (0);
  vga_unlockvc ();
  Cell::clearImage (imageData[nDrawPage]);
}

////////////////////////////////////////////////////////Ԥ
void Masl::waitBeforePlaying (int docwait)
{//docwaitäΩĤʤˤkeyޤԤ
  timeval baseTime;
  timeval nowTime;
  gettimeofday (&baseTime,NULL);
  gettimeofday (&nowTime,NULL);
#if 0
  XEvent tmpEvent;//ϼXCheckMaskEventΰ˻Ȥ
  while (nowTime.tv_sec-baseTime.tv_sec<docwait &&
	 !XCheckMaskEvent (display,KeyPressMask||ExposureMask,&tmpEvent))
    gettimeofday (&nowTime,NULL);
#endif
}
