/* 
        Masl.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarincode򸵤YamahataľʪǤ
	MITSHM extentionʬĹ(nagano@i.kyushu-u.ac.jp )
	xmasl򻲹ͤˤƤޤ

*/


#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/time.h>
//#include <time.h>
#include <iostream.h>
#include <assert.h>
#include <errno.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>

#ifdef RENICE
#include <sys/resource.h>
#include <unistd.h>
#endif //RENICE

#include <vga.h>
#include <vgagl.h>

#ifndef masl_h
#define masl_h

#include "MaslConst.h"
#include "MaslInputStream.h"
#include "MaslScenario.h"
#include "Cell.h"
#include "CellAhead.h"
#include "CellStatic.h"
#include "CellStaticLowMemory.h"
#include "Pcm.h"
#include "SvgaPalette.h"
#include "Timer.h"

#define MAXLOOP 64//롼פΥͥȲǽ
#define MAXCALL 64//֥롼󥳡ΥͥȲǽ
#define MAXPCMCH 8//PCMͥκ

class Masl
{
  //variables
#ifdef TEST_AK5
public:
#else
private:
#endif
  //masl fileheader
  //char MSL[9];
  const int argc;
  char** const argv;//command line option

  MaslScenario* scenario;
  void waitBeforePlaying (int docwait);
  //ǡmethodǾdocwaitԤ

  //ޤdataξ
  Cell* pCell[MAXCELL];//object
  int numberOfCell;//dataο
  SvgaPalette* pPalette[MAXPAL];//palette object
  int numberOfPalette;//paletteο
  Pcm* pPcm[MAXPCM];//PCM object
  int numberOfPcm;//PCM dataο

  ////////////////////////////////////////////////////windowɽѤΰ٤ѿ
  int gSvgaMode;//svgagraphic mode
  GraphicsContext* physicalScreen;//̤context(svga glȤΤɬס)
  void setSvgaMode (int mode)
    {
      vga_lockvc ();
      if (vga_oktowrite ())
	{
	  vga_setmode (mode);
	  gl_setcontextvga (mode);
	}
      vga_unlockvc ();
    };


  unsigned char* imageData[2];//ximagedata field
  unsigned char* imageDataOf200Line;//200 line modeλ˻Ѥ

  //////////////////////////////////////////////////////////maslΰ٤ѿ
  const char* pt;//ߤscenarioΰ֤ؤpointer()
  
  const char* callStack[MAXCALL];//֥롼󥳡
  short numberOfCall;//call stackο

  short loopCounter[MAXLOOP];//loop counter
  //=-1λ̵loopޤϾloop,ȽloopǤ
  short numberOfLoop;//loopΥͥȿ

  int intVar[MAXVAR];//ѿ
  Bool is200LineMode;//200line mode
                     //True =200line mode
                     //False=400line mode
  Bool isGraphicOn;//graphicɽ on(=True) off(=False)
  RECT viewPort;//view portɽmask
  short nShowPage;//ɽpage(0 or 1)
  short nDrawPage;//page(0 or 1)
  short nPalette;//ߤpaletteֹ
  int nVramOrg;//GDC scrollѤVRAMɽ֤롣
  int gdcLoop;//GDC scrollloopbyteǲ̤loop
  
  ///////////////////////////////////////////timerԤ  
  /*
  int hz;//ޥ󥿤®(ô֤hz/100󥿤ʤ)
           //i.e ñ̤10^(-2)Hz
           //ĤޤT Hzʤhz=T*100
  timeval dwTickCount;//ϻˤtv_sec=tv_usec=0
                      //ˤʤäƤ롣
  timeval timerCount;//ּ(ޥ)
  //ǼºݤΥޥȤ
  //(
  // (timerCount.tv_sec-dwTickCount.tv_sec)*1000000+
  // (timerCount.tv_usec-dwTickCount.tv_usec)
  // )*hz/1000000
  // ˤʤ
  //timer countԤ
  //int timeCntForWait;//timer countԤ򤷤ƤΤcounterޤԤġ
  */
  Timer timer;
  long timeCntForWait;//timer countԤ򤷤ƤΤcounterޤԤġ
  Bool isWaiting;//timer countԤ򤷤Ƥ뤫
                 //True:Ƥ False:Ƥʤ

  //////////////////////////////////////////Ÿɬס
  int aheadlyExtractedCellNumber;
  //ŸƤֹ档
  //=-1λŸƤʤ(٤ƤӽФƤʤ)

  CellAhead* cellAhead;//Ÿ٤ʪ

  ///////////////////////////////////////////////////////////PCMΰ٤ʪ
  unsigned char isAudioWriting;//write٤PCM dataͭ뤫
  //(ʤBoolͤ8ޤǤʤ餽줾bitɽ)
  unsigned char isAudioWaiting;//PCMκλԤ򤷤Ƥ뤫

  ///////////////////////////////////////////////////////////err command
  int* errorLevel;//λ֤error levelؤpointer
  //=NULL(error levelλ̵default) or
  //=&normalExit:̾ｪλ
  //=&escapeExit:escape keyǽλ
  int normalExit;//̾ｪλ֤͡
  int escapeExit;//escapeǽλ֤͡
public://error level٤access method
  int getErrorLevel (){return (errorLevel==NULL)?0:*errorLevel;};
  //==NULLλ0ȤΤä˰̣ͭޤ
private:

  ////////////////////////////////////////////////////////////X Event
  //XEvent event;//Xevent
  //static const long maslEventMask;//=KeyPressMask|ExposureMask|
  //ButtonPressMask|ButtonReleaseMask|Button1MotionMask;//event mask
  //ϻŪǽ䤹Ϥäɬ
  int isKeyPressed (const KeySym keysym,const char keyVector[32]);
  //keyƤ뤫ݤȽ򤹤롣
  //keycodeбkeyƤС1֤
  //Ǥʤ0֤

  ///////////////////////////////////////xmaslФoptionν
private:
  XMASL_OPTION xmaslOption;
  void setXmaslOption (XMASL_OPTION xmaslOption);
  

  //methods
private:
  ///////////////////////////////////////////////////////////////
  Bool ak5Load (MaslInputStream& maslIs);
  Bool pknLoad (MaslInputStream& maslIs);
  Bool loadAll (const char* const filename);
  void allocColors ();//

  ////////////////////////////////////////////////////////scenario
  Bool isOptionSpecified (char c);
  Bool isOptionSpecified2 (const char*& opts);
  int getOptionValue (char c);
  int searchnum ();
  int searchnum (const char* pt);
  int getValue ();
  Bool searchNextCommand ();
  Bool joukenHantei ();

public:
  Masl (const int __argc,char** const __argv,
	const char* const filename,
	XMASL_OPTION maslXmaslOptoin);
  ~Masl ();
  //ʲmaslκɬפmethod
  void preparePlay ();//ν
  //ѿaudio deviceμ
  Bool play ();//play loopXEvent queˤƤɬפͭ?
  void afterPlay ();//playˤƤǤ
  //audio deviceclose򤹤
  void updateWindow ();//ľXPutImageѤꡢ
                       //ɽ̤ˤɤΤʤ
  void putImage ();//imagewindowĥդ롣
  void clearWindow ();//̤clear

  //////////////////////////////////////access method
  int getNumberOfCells () const {return numberOfCell;};
  int getNumberOfPalettes () const {return numberOfPalette;};
  int getNumberOfPcm () const {return numberOfPcm;};
  int getAheadlyExtractedCellNumber () const
    {return aheadlyExtractedCellNumber;};
  int getTimeCounter () const {return timer.getTimerCount ();};
  int getNowCount () const {return timer.getNowCount ();};
  int getShowPage () const {return nShowPage;};
  int getDrawPage () const {return nDrawPage;};
  int getCurrentPaletteNumber () const {return nPalette;};
  int getVramOrg () const {return nVramOrg;};
  int getGDCLoopLength () const {return gdcLoop;};
  Bool getIs200LineMode () const {return is200LineMode;};
  RECT getViewPort () const {return viewPort;};
  long getTimeCntForWait () const {return timeCntForWait;};
  Bool getIsWaiting () const {return isWaiting;};
  Bool getIsAudioWriting () const {return isAudioWriting;};
  Bool getIsAudioWaiting () const {return isAudioWaiting;};




  //////////////////////////////////////////////////ʲmaslcommand

/*
  static const char spaceTable[]={' ','\t','\r','\n',';'};
*/  
  ///////////////////////////////////////////˻Ȥͤ٤ʪ
private:
  struct VALUE_COMMAND
  {
    char value;
    int (*getValue) (Masl& masl);
  };
  static const VALUE_COMMAND valueTable[];
  static const int NUMBER_VALUE;
  
public://privateˤ٤ʤ
  static int getValueDigit (Masl& masl);
  static int getValueRand (Masl& masl);
  static int getValueVar (Masl& masl);
  static int getValueKey (Masl& masl);
  static int getValueOption (Masl& masl);
  static int getValueTimer (Masl& masl);
  static int getValuePCMState (Masl& masl);


private:
  struct MASL_COMMAND
  {
    char* command;
    void (*executeCommand) (Masl& masl);
  };

  //friend struct MASL_COMMAND;
  static const MASL_COMMAND commandTable[];
  static const int numberOfCommand;
public://privateˤ٤ʤ
  /////////////////////////////////////////////////////////////
  static void cmdLeftBracket (Masl& masl);
  static void cmdRightBracket (Masl& masl);
  static void cmdLeftBrace (Masl& masl);
  static void cmdRightBrace (Masl& masl);
  static void cmdLabel (Masl& masl);
  static void cmdJump (Masl& masl);
  static void cmdCall (Masl& masl);
  static void cmdRet (Masl& masl);
  ///////////////////////////////////////////////////////////math
  static void cmdLet (Masl& masl);
  static void cmdPlus (Masl& masl);
  static void cmdMinus (Masl& masl);
  static void cmdTimes (Masl& masl);
  static void cmdDivide (Masl& masl);
  static void cmdModulo (Masl& masl);
  static void cmdAnd (Masl& masl);
  static void cmdOr (Masl& masl);
  static void cmdXor (Masl& masl);
  ///////////////////////////////////////////////////////////graphics 
  static void cmdGon (Masl& masl);
  static void cmdGoff (Masl& masl);
  static void cmdLine (Masl& masl);
  static void cmdPw (Masl& masl);
  static void cmdPd (Masl& masl);
  static void cmdD (Masl& masl);
  static void cmdCls (Masl& masl);
  static void cmdBox (Masl& masl);
  static void cmdO2u (Masl& masl);
  static void cmdU2o (Masl& masl);
  static void cmdPal (Masl& masl);
  static void cmdPalNum (Masl& masl);
  static void cmdMove (Masl& masl);
  static void cmdRoll (Masl& masl);
  static void cmdTone (Masl& masl);
  static void cmdMask (Masl& masl);
  static void cmdPmix (Masl& masl);
  ///////////////////////////////////////////////////////////////pcm
  static void cmdPcm (Masl& masl);
  static void cmdRate (Masl& masl);
  static void cmdPst (Masl& masl);
  static void cmdPwt (Masl& masl);
  ////////////////////////////////////////////timer counter
  static void cmdCount (Masl& masl);
  static void cmdTc (Masl& masl);
  static void cmdT (Masl& masl);
  /////////////////////////////////////////////////////etc.
  static void cmdOut (Masl& masl);
  static void cmdError (Masl& masl);
  static void cmdComment (Masl& masl);
  static void extractCellAhead (Masl& masl);
};
#endif//masl_h
