/* 
        svgapalette.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	shimarincode򸵤Yamahata񤤤ʪǤ
*/
#include <vgagl.h>

#include "MaslConst.h"
#include "SvgaPalette.h"

PALETTE SvgaPalette::paletteOfNow[NUMBER_OF_COLORS];

void SvgaPalette::setXColor (PALETTE& xcolor,
			     const int r,const int g,const int b,
			     const int contrast=100)
{
  xcolor.r=((((unsigned short) r)*contrast/100) << 2)%64;
  xcolor.g=((((unsigned short) g)*contrast/100) << 2)%64;
  xcolor.b=((((unsigned short) b)*contrast/100) << 2)%64;
}



SvgaPalette::SvgaPalette (MaslInputStream& maslIs)
{
  //fread (fileName,1,16,fp);//file nameɤߤ
  maslIs.read (fileName,16);
  fileName[16]='\0';

  unsigned char buffer[NUMBER_OF_COLORS*3];//dataɤ߹Ѥbuffer
  maslIs.read (buffer,sizeof (buffer));//dataɤ߹
  int c=0;
  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {//palette
      palette[i].r=buffer[c];
      c++;
      palette[i].g=buffer[c];
      c++;
      palette[i].b=buffer[c];
      c++;
    }
}

SvgaPalette::~SvgaPalette ()
{
}

void SvgaPalette::setPalette (int contrast=100)
{
  assert (0<=contrast && contrast<=100);
  
  PALETTE xcolor[NUMBER_OF_COLORS];
  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {
      const int r=palette[i].r;
      const int g=palette[i].g;
      const int b=palette[i].b;
      
      paletteOfNow[i].r=r;
      paletteOfNow[i].g=g;
      paletteOfNow[i].b=b;
      setXColor (xcolor[i],r,g,b,contrast);
    }
  vga_lockvc ();
  if (vga_oktowrite ())
    gl_setpalettecolors (0,NUMBER_OF_COLORS,xcolor);
  vga_unlockvc ();
}

void SvgaPalette::setPalette (const int paletteNumber,
			      const int r,const int g,const int b,
			      const int contrast=100)
{
  assert (0<=contrast && contrast <=100);
  vga_lockvc ();
  if (vga_oktowrite ())
    {
      gl_setpalettecolor (paletteNumber%NUMBER_OF_COLORS,
			  ((r*contrast/100)<< 2)%64,
			  ((g*contrast/100)<< 2)%64,
			  ((b*contrast/100)<< 2)%64);
    }
  vga_unlockvc ();
}

void SvgaPalette::setTone (const int contrast)
{
  PALETTE xcolor[NUMBER_OF_COLORS];
  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {
      setXColor (xcolor[i],
		 paletteOfNow[i].r,paletteOfNow[i].g,paletteOfNow[i].b,
		 contrast);
    }
  
  vga_lockvc ();
  if (vga_oktowrite ())
    gl_setpalettecolors (0,NUMBER_OF_COLORS,xcolor);
  vga_unlockvc ();
}

void SvgaPalette::mix (const int paletteNumber1,const int paletteNumber2,
		   const int ratio,const int contrast=100)
{
  assert (0<=ratio);
  assert (ratio<=100);

  const int r1=paletteOfNow[paletteNumber1].r;
  const int g1=paletteOfNow[paletteNumber1].g;
  const int b1=paletteOfNow[paletteNumber1].b;
  const int r2=paletteOfNow[paletteNumber2].r;
  const int g2=paletteOfNow[paletteNumber2].g;
  const int b2=paletteOfNow[paletteNumber2].b;
  
  vga_lockvc ();
  if (vga_oktowrite ())
    {
      setPalette (paletteNumber1,
		  (r1*ratio+r2*(100-ratio))/100,
		  (g1*ratio+g2*(100-ratio))/100,
		  (b1*ratio+b2*(100-ratio))/100,
		  contrast);
      setPalette (paletteNumber2,
		  (r1*(100-ratio)+r2*ratio)/100,
		  (g1*(100-ratio)+g2*ratio)/100,
		  (b1*(100-ratio)+b2*ratio)/100,
		  contrast);
    }
  vga_unlockvc ();
}
