/* 
        extractCell.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarinwin maslβŸΤ򸵤Yamahata
	ޤκݤIIZUKA Daisukeshowak5souce code
	򻲹ͤˤƤޤ
*/

#include "MaslConst.h"
#include "Cell.h"

//ak5 command 
#define AK5_ADD       0
#define AK5_DRAW_DEF  1
#define AK5_DRAW_1    3
#define AK5_DRAW_2   11
#define AK5_DRAW_N    7
#define AK5_END      15
#define AK5_EACHLINE 31
#define AK5_DRAW_16  47

Bool Cell::extractCell2XImage (XImage* const ximage,
			       const int maslOffset=0,
			       const int maslGdcLoop=PLANE_LENGTH)
{
  return extractCell2XImage (cellData,(unsigned char*) ximage->data,
			     maslOffset,maslGdcLoop);
}

Bool Cell::extractCell2XImage (unsigned char* const imageData,
			       const int maslOffset=0,
			       const int maslGdcLoop=PLANE_LENGTH)
{
  return extractCell2XImage (cellData,imageData,maslOffset,maslGdcLoop);
}

Bool Cell::extractCell2XImage (unsigned char* const cellData,
			       unsigned char* const imageData,
			       const int maslOffset=0,
			       const int maslGdcLoop=PLANE_LENGTH)
{
  unsigned char* cellPointer=cellData;
  unsigned char* const imagePointer=imageData;

  //assert (0<=offset);
  //assert (offset<=VRAM_LENGTH);
  //address=offset%32767;
  //Ϥäȸⲽͭ롣ΤޤޤǤܡ
  //offset<0ȤʤΤGDC scrollȤäƤǤꡢ
  //λθʤȤʤCellStatic::extractCellǤƱ͡
  gdcLoop=maslGdcLoop;
  offset=maslOffset%VRAM_LENGTH;
  address=0;
  assert (-gdcLoop<=offset);
  assert (offset<VRAM_LENGTH);
  
  gdc.b=gdc.r=gdc.g=gdc.e=0;
  Bool isSkip2Line=False;


  while (*cellPointer!=AK5_END)
    {
      if (((*cellPointer)& 0x01)==AK5_ADD)
	{ //xxxxxxx0
	  //ߤ1byte̡1byte򲼰,Ȥaddress­
	  //address=(address+((*cellPointer)>>1)*256+*(cellPointer+1))&0x7fff;
	  //assert (-gdcLoop<=address && address<=VRAM_LENGTH);
	  address+=((*cellPointer)>>1)*256 + *(cellPointer+1);
	  /*
	  if (address>VRAM_LENGTH)//VRAMκǸޤǹԤäΤǺǽ롣
	    address-=VRAM_LENGTH;
	  */
	  address%=VRAM_LENGTH;
	  //address&=(VRAM_LENGTH-1);
	  assert (0<=address && address<=VRAM_LENGTH);
	  cellPointer+=2;
	  continue;
	}

      if (((*cellPointer)&0x03)==AK5_DRAW_DEF)
	{//xxxxxx01
	 //ߤbyteʬGRCG1byte(8dot)褷Ƥ鲼address򤺤餹
	 //Τ򷫤֤
	  unsigned char n=(*cellPointer++)>>2;
	  for (unsigned char i=0;i<n;i++)
	    {
	      GRCG2XImage (address,imagePointer);
	      nextLine (isSkip2Line);
	    }
	  continue;
	}
      
      if (((*cellPointer)&0x0f)==AK5_DRAW_1)
	{ //xxxx0011=E:G:R:B:0:0:1:1
	  //GRCGͤꤷ褷address򲼤ˤ餹
	  //B,R,G,EbitΤΩäƤplaneGRCG dataΤ
	  //ѹ롣ѹdataϡbyte˼ޤäƤ롣

	  //դ̵̤ʽ򤷤Ƥ롣äȴñˤʤȦ
	  //drawN (2,,,),drawN (n,,,)Ʊ͡
	  //¿ʬcellPointerpointerϤˤ(&cellPointer)ɤΤ
	  unsigned char GRCG=*cellPointer++>>4;
	  drawN (1,GRCG,cellPointer,imagePointer,isSkip2Line);
#if 0
	  if((GRCG&GDC_B_MASK)!=0)gdc.b=*cellPointer++;
	  if((GRCG&GDC_R_MASK)!=0)gdc.r=*cellPointer++;
	  if((GRCG&GDC_G_MASK)!=0)gdc.g=*cellPointer++;
	  if((GRCG&GDC_E_MASK)!=0)gdc.e=*cellPointer++;
	  
	  GRCG2XImage (address,imagePointer);
	  nextLine (isSkip2Line);
#endif
	  continue;
	}
      
      if (((*cellPointer)&0x0f)==AK5_DRAW_2)
	{ //xxxx1011=EGRB1011
	  //Ʊ,addressѹ2Ԥʤ
	  //㤨01111011ξ硢byteB,R,G,B,R,Gȸդ
	  //Ǽ롣
	  unsigned char GRCG=*cellPointer++>>4;
	  drawN (2,GRCG,cellPointer,imagePointer,isSkip2Line);
#if 0
	  if((GRCG&GDC_B_MASK)!=0)gdc.b=*cellPointer++;
	  if((GRCG&GDC_R_MASK)!=0)gdc.r=*cellPointer++;
	  if((GRCG&GDC_G_MASK)!=0)gdc.g=*cellPointer++;
	  if((GRCG&GDC_E_MASK)!=0)gdc.e=*cellPointer++;
 
	  GRCG2XImage (address,imagePointer);
	  nextLine (isSkip2Line);
 
	  if((GRCG&GDC_B_MASK)!=0)gdc.b=*cellPointer++;
	  if((GRCG&GDC_R_MASK)!=0)gdc.r=*cellPointer++;
	  if((GRCG&GDC_G_MASK)!=0)gdc.g=*cellPointer++;
	  if((GRCG&GDC_E_MASK)!=0)gdc.e=*cellPointer++;
 
	  GRCG2XImage (address,imagePointer);
	  nextLine (isSkip2Line);
#endif
	  continue;
	}
      
      if (((*cellPointer)&0x0f)==AK5_DRAW_N)
	{ //xxxx0111=EGRB0111
	  //ƱԤʤϡbyteplane dataδ֤
	  //byte(+2)
	  //datanܤ롣
	  unsigned char GRCG=*cellPointer++>>4;
	  int n=(*cellPointer++)+2;//֤
	  drawN (n,GRCG,cellPointer,imagePointer,isSkip2Line);
	  continue;
	}

      if (*cellPointer==AK5_EACHLINE)
	{ //00001111
	  //줬¹Ԥ줿褬1lineˤʤ롣
	  //⤦ټ¹ԤȲ(i.e toggle)
	  //isSkip2Line=isSkip2Line?False:True;
	  isSkip2Line=!isSkip2Line;
	  cellPointer++;
	  continue;
	}

      if (*cellPointer==AK5_DRAW_16)
	{//00101111
	  //16dot
	  //byte4οGRCG2byte(16bit)褷Ƥ
	  //address򤺤餹Τ򷫤֤
	  //1lineˤʤäƤbyte5Ȥʤ
	  // ʤߤˣǣңãǤˤϥХ(8ɥå)ʬǡʤ
	  // ᡢɤξ̤Ȳ̤ƱǡȤʤ
	  int n=(*++cellPointer) / (isSkip2Line?5:4);
	  for (int i=0;i<n;i++)
	    {
	      GRCG2XImage (address,imagePointer);
	      GRCG2XImage (address+1,imagePointer);
	      nextLine (isSkip2Line);
	    }
	  cellPointer++;
	  continue;
	}

      //̾盧ˤʤ
      cerr << "Eror:Unknown AK5 format" << endl;
      return False;      
      
    }//while

  return True;
}

void Cell::GRCG2XImage (const int address,
			unsigned char* const imagePointer)
{
  int tmpAddress=((address+offset>=0)?
		  address+offset:(address+offset+gdcLoop));
  
  tmpAddress%=VRAM_LENGTH;
  assert (0<=tmpAddress);

  for (int i=0;i<8;i++)
    {
      //b=plane 0,r=plane 1,g=plane 2,e=plane 3Ǥա
      *(imagePointer+tmpAddress*8+i)=palette2Pixel
	[(((gdc.b << i)&0x80) >> 7)|(((gdc.r << i)&0x80) >> 6)|
	 (((gdc.g << i)&0x80) >> 5)|(((gdc.e << i)&0x80) >> 4)];


/*
      //8bit˷ᤦƤ롣
      *(imagePointer+tmpAddress*8+i)=
	basePixel|
	(((gdc.b << i)&0x80)?planeMask.b:0)|
	(((gdc.r << i)&0x80)?planeMask.r:0)|
	(((gdc.g << i)&0x80)?planeMask.g:0)|
	(((gdc.e << i)&0x80)?planeMask.e:0);
*/
    }
}


void Cell::nextLine (const Bool isSkip2Line)
{
  //address=(address+(isSkip2Line?(SIZE_X*2/8):(SIZE_X/8)))&0x7fff;
  address+=(isSkip2Line?(SIZE_X*2/8):(SIZE_X/8));
  /*
  if (address>VRAM_LENGTH)//VRAMκǸޤǹԤäΤǺǽ롣
    address-=VRAM_LENGTH;
  */
  address%=VRAM_LENGTH;
  assert (0<=address && address<=VRAM_LENGTH);
}

void Cell::drawN (const int n,const unsigned char GRCG,
		  unsigned char*& cellPointer,
		  unsigned char* const imagePointer,
		  const Bool isSkip2Line)
{
  const Bool isChangeB=((GRCG&GDC_B_MASK)!=0);
  const Bool isChangeR=((GRCG&GDC_R_MASK)!=0);
  const Bool isChangeG=((GRCG&GDC_G_MASK)!=0);
  const Bool isChangeE=((GRCG&GDC_E_MASK)!=0);

  for (int i=0;i<n;i++)
    {
      if (isChangeB)gdc.b=*cellPointer++;
      if (isChangeR)gdc.r=*cellPointer++;
      if (isChangeG)gdc.g=*cellPointer++;
      if (isChangeE)gdc.e=*cellPointer++;

      GRCG2XImage (address,imagePointer);
      nextLine (isSkip2Line);
    }
}
